﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr170_1
{
    // Объявление делегата: 
    delegate int MyDelegate(int n);
    
    // Класс с главным методом: 
    class Program
    {
        // Статический метод для вычисления нечетньк чисел: 
        static int f(int n) { 
            return 2 * n + 1;
        }
        // Статический метод для вычисления четных чисел: 
        static int g(int n) { 
            return 2 * n;
        }
        // Статический метод для вычисления квадратов чисел: 
        static int h(int n) { 
            return n * n;
        }
        // Статический метод, которому аргументом 
        // передается ссылка на метод: 
        static void display(MyDelegate F, int a, int b) { 
            Console.WriteLine("{0, -4}| {1, 4}", "x", "F(x)");
            Console.WriteLine("----------");
            for(int k = a; k <= b; k++) {
                // Команда с вызовом экземпляра делегата: 
                Console.WriteLine("{0,-4}|{1,4}", k, F(k));
            }
            Console.WriteLine();
        }

        // Главный метод: 
        static void Main()
        {
            // Диапазон изменения аргумента: 
            int a = 0, b = 5;
            Console.WriteLine("Нечетные числа:");
            // Передача аргументом ссылки на метод: 
            display(f, a, b);
            Console.WriteLine("Четные числа:");
            // Передача аргументом ссылки на метод: 
            display(g, a, b);
            Console.WriteLine("Числа в квадрате:");
            // Передача аргументом ссылки на метод: 
            display(h, a, b);
            // Задержка:
            Console.ReadLine();
        }
    }
}
